# XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
# THIS IS BLOATED BEYOND BELIEF...
# RIPPED FROM CMFMEMBER FOR NOW
# XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

try:
    from Products.CMFCore.interfaces.portal_memberdata import MemberData \
         as IMemberData
    memberdata_interface = 1
except:
    memberdata_interface = 0

import types
import copy
import urllib
import random

from DateTime import DateTime

from AccessControl import ClassSecurityInfo, ModuleSecurityInfo, User, \
     Unauthorized
from AccessControl.PermissionRole import rolesForPermissionOn
from Acquisition import aq_inner, aq_parent, aq_base, aq_chain, aq_get
from ZODB.POSException import ConflictError

from Products import CMFCore
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import getToolByName, _limitGrantedRoles, \
     _verifyActionPermissions
from Products.CMFCore.Expression import createExprContext
from Products.Archetypes.public import *
from Products.Archetypes.debug import log
from Products.Archetypes.Schema import Schemata
from Products.Archetypes.VariableSchemaSupport import VariableSchemaSupport

from Products.Membrane.permissions import VIEW_PUBLIC_PERMISSION, \
     EDIT_ID_PERMISSION, VIEW_OTHER_PERMISSION, EDIT_PROPERTIES_PERMISSION, \
     VIEW_SECURITY_PERMISSION, EDIT_PASSWORD_PERMISSION, \
     EDIT_SECURITY_PERMISSION, MAIL_PASSWORD_PERMISSION, ADD_MEMBER_PERMISSION, \
     VIEW_PERMISSION, REGISTER_PERMISSION

from Products.Membrane.types.schemata import id_schema, contact_schema, plone_schema, security_schema, login_info_schema, content_schema

_marker = []
class Member(BaseContent):
    """A description of a member"""

    security = ClassSecurityInfo()
    archetype_name = portal_type = meta_type = 'Member'

    # Give a nice icon
    content_icon = "defaultUser.gif"

    # Note that we override BaseContent.schema
    schema = content_schema + ExtensibleMetadata.schema

    global_allow = 0

    def __init__(self, userid):
        BaseContent.__init__(self, userid)
        self.id = str(userid)

        self.fullname = ''
        self.email = ''

        # for plone compatibility
        self.listed = 0
        self.login_time = '2000/01/01'
        self.last_login_time = '2000/01/01'

    # ########################################################################
    # User interface
    security.declarePublic('Title')
    def Title(self):
        try:
            title = self.Schema()['title'].get(self)
        except KeyError:
            title = ''
        if not title and self.getFullName():
            return self.getFullName()
        elif not title:
            return self.id
        else:
            return title

    security.declarePublic('getUserName')
    def getUserName(self):
        """Return the username of a user"""
        return self.getUser().getUserName()

    security.declareProtected(VIEW_PUBLIC_PERMISSION, 'getFullName')
    def getFullName(self):
        return self.fullname

    security.declareProtected(VIEW_PUBLIC_PERMISSION, 'getEmail')
    def getEmail(self):
        return self.email

    security.declareProtected(VIEW_OTHER_PERMISSION, 'getLastLoginTime')
    def getLastLoginTime(self):
        return self.last_login_time

    security.declareProtected(EDIT_PROPERTIES_PERMISSION, 'setFullName')
    def setFullName(self, fullname):
        self.fullname = fullname

    security.declareProtected(EDIT_PROPERTIES_PERMISSION, 'setEmail')
    def setEmail(self, email):
        self.email = email

    security.declareProtected(EDIT_PROPERTIES_PERMISSION, 'setLastLoginTime')
    def setLastLoginTime(self, last_login_time):
        self.last_login_time = last_login_time

    security.declarePublic('getPortalSkin')
    def getPortalSkin(self):
        portalskin = self.Schema()['portal_skin'].get(self)
        try:
            skins_tool = getToolByName(self, 'portal_skins')
            if portalskin in skins_tool.getSkinSelections():
                return portalskin
            else:
                return skins_tool.getDefaultSkin()
        except AttributeError:
            return portalskin

    #for compatibility to CMFCore member handling
    security.declarePrivate('setMemberProperties')
    def setMemberProperties(self,props):
        return self.edit(**props)

    ######################################
    # group management methods

    def getGroups(self):
        ''' fetches the groups from GRUF '''
        acl_users=getToolByName(self,'acl_users')

        user=self.getUser()

        # not a registered member yet, groups are stored in roles
        if not self.hasUser():
            pref = acl_users.getGroupPrefix()
            groups = [g[len(pref):] for g in self.getRoles() \
                      if g.startswith(pref)]
            return groups

        if not hasattr(user,'getGroups'): #return empty list if user comes another acl_user
            return []

        groups=user.getGroups()
        try:
            res = [g.getUserNameWithoutGroupPrefix() \
                   for g in groups if g.getUserNameWithoutGroupPrefix()]
        except AttributeError:
            # then the groups come as array of strings
            pref=acl_users.getGroupPrefix()
            res = [g[len(pref):] for g in groups if g != pref]

        return res


    def getRawGroups(self):
        '''fetches the Group names from GRUF with prefix '''
        user=self.getUser()
        acl_users=getToolByName(self,'acl_users')
        pref=acl_users.getGroupPrefix()

        # not a registered member yet, groups are stored in roles
        if not self.hasUser():
            groups = [g for g in self.getRoles() \
                      if g.startswith(pref)]
            return groups

        if not hasattr(user,'getGroups'): #return empty list if user comes another acl_user
            return []

        groups=user.getGroups()
        try:
            res = [g.getId() for g in groups if g.getId() != pref]
        except AttributeError:
            res = [g for g in groups if g != pref]
        return res

    def valid_groups(self):
        acl_users=getToolByName(self,'acl_users')
        if not hasattr(acl_users,'getGroups'):
            return []
        groups=acl_users.getGroups()
        res = [g.id for g in groups if g.id]
        return res

    def _getUserAndGroupRoles(self):
        """Return effective roles for this user, determines directly and
        by assigned groups"""
        acl_users=getToolByName(self,'acl_users')
        pref=acl_users.getGroupPrefix()
        valid_groups = acl_users.getGroupNames()
        roles = list(self.getFilteredRoles())
        for group in self.getRawGroups():
            if group not in valid_groups:
                continue
            roles.extend(acl_users.getGroup(group).getUserRoles())
            try:
                roles.remove(group)
            except ValueError:
                pass
        return unique(roles)

    # ########################################################################
    # Validators and vocabulary methods

    import re
    __ALLOWED_MEMBER_ID_PATTERN = re.compile( "^[A-Za-z][A-Za-z0-9_]*$" )
    security.declarePrivate('validate_id')
    def validate_id(self, id):
        # we can't always trust the id argument, b/c the autogen'd
        # id will be passed in if the reg form id field is blank
        form = self.REQUEST.form
        if form.has_key('id') and not form['id']:
            return self.translate('Input is required but no input given.',
                                  default='You did not enter a login name.'),
        elif self.id and id != self.id:
            # don't validate if we're not changing the user id
            memberdata_tool = getToolByName(self, 'portal_memberdata')
            if memberdata_tool.has_key(id) or \
                   not self.__ALLOWED_MEMBER_ID_PATTERN.match( id ) or \
                   id == 'Anonymous User':
                msg = "The login name you selected is already " + \
                      "in use or is not valid. Please choose another."
                return self.translate(msg, default=msg)

    security.declarePublic('isValid')
    def isValid(self):
        """ Check to make sure a Member object's fields satisfy schema constraints"""
        errors = {}
        # make sure object has required data and metadata
        self.Schema().validate(self, None, errors, 1, 1)
        if errors:
#            import sys
#            sys.stdout.write('isValid, errors = %s\n' % (str(errors)))
            return 0
        return 1

    # Vocabulary methods
    def editors(self):
        return self.portal_properties.site_properties.available_editors

    def valid_roles(self):
        return self.getUser().valid_roles()

    def available_skins(self):
        # give managers the ability to choose any skin
        managePortal = getToolByName(self, 'portal_membership').checkPermission(CMFCorePermissions.ManagePortal, self)
        skins_tool = getToolByName(self, 'portal_skins')
        if skins_tool.getAllowAny() or managePortal:
            return getToolByName(self, 'portal_skins').getSkinSelections()
        else:
            return [self.getPortalSkin()]


    def getDefaultSkin(self):
        return getToolByName(self, 'portal_skins').getDefaultSkin()

    # ########################################################################
    # Contract with portal_membership

    security.declarePublic('getMemberId')
    def getMemberId(self):
        """Get the member id """
        return self.getUserName()


    security.declareProtected(EDIT_PROPERTIES_PERMISSION, 'setProperties')
    def setProperties(self, mapping=None, **kwargs):
        """assign all the props to member attributes, we expect
        to be able to find a mutator for each of these props
        """
        #We know this is an Archetypes based object so we look for
        #mutators there first

        # if mapping is not a dict, assume it is REQUEST
        if mapping:
            if not type(mapping) == type({}):
                data = {}
                for k,v in mapping.form.items():
                    data[k] = v
                mapping = data
        else:
            mapping = {}

        if kwargs:
            # mapping could be a request object thats not really a dict,
            # this is what we get
            mapping.update(kwargs)

        for fieldname in mapping.keys():
            # have to check permissions by hand... ugh!
            field = self.getField(fieldname)
            if field and not field.checkPermission("edit", self):
                raise Unauthorized

        self.update(**mapping)

        # XXX - there has to be a better way!!
        if mapping.has_key('login_time'):
            self.login_time = mapping['login_time']
        if mapping.has_key('last_login_time'):
            self.setLastLoginTime(mapping['last_login_time'])


    security.declarePrivate('setMemberProperties')
    def setMemberProperties(self, mapping):
        self.setProperties(mapping)


    def _getProperty(self, id):
        """Try to get a member property.  If the property is not found,
        raise an AttributeError"""
        field = self.Schema().get(id, None)
        if field is not None:
            if not field.checkPermission('view', self):
                raise Unauthorized
            accessor = getattr(self, field.accessor, None)
            value = accessor()
        else:
            base = aq_base(self)
            value = getattr(base, id)
        return value


    security.declarePublic('getProperty')
    def getProperty(self, id, default=_marker):
        try:
            return self._getProperty(id)
        except AttributeError:

            # member does not have a value for given property
            # try memberdata_tool for default value
            memberdata_tool = getToolByName(self, 'portal_memberdata')
            tool_value = memberdata_tool.getProperty(id, _marker)
            user_value = getattr(self.getUser(), id, _marker)

            # If the tool doesn't have the property, use user_value or default
            if tool_value is _marker:
                if user_value is not _marker:
                    return user_value
                elif default is not _marker:
                    return default
                else:
                    raise ValueError, 'The property %s does not exist' % id

            # If the tool has an empty property and we have a user_value, use it
            if not tool_value and user_value is not _marker:
                return user_value

            # Otherwise return the tool value
            return tool_value

    def isListed(self):
        # XXX this is rather inflexible...
        roles = rolesForPermissionOn('View', self)
        if 'Member' in roles:
            return 'Yes'
        else:
            return 'No'


    # ########################################################################
    # Overrides of base class mutators that trigger workflow transitions

    def update(self, **kwargs):
        membership_tool = getToolByName(self, 'portal_membership')
        updateSelf = membership_tool.getAuthenticatedMember().getUserName() == self.getUserName()
        ret = BaseContent.update(self, **kwargs)
        # XXX need better test for password update
        if updateSelf and kwargs.has_key('password'):
            self._updateCredentials()
        # invoke any automated workflow transitions after update
        triggerAutomaticTransitions(self)
        return ret


    def processForm(self, data=1, metadata=0, REQUEST=None, values=None):
        membership_tool = getToolByName(self, 'portal_membership')
        updateSelf = membership_tool.getAuthenticatedMember().getUserName() == self.getUserName()
        ret = BaseContent.processForm(self, data, metadata, REQUEST, values)
        if updateSelf:
            update_credentials = False
            # XXX need better test for password update
            if REQUEST and REQUEST.has_key('password'):
                update_credentials = True
            elif self.REQUEST and self.REQUEST.has_key('password'):
                update_credentials = True
            if update_credentials:
                self._updateCredentials()
        # invoke any automated workflow transitions after update
        triggerAutomaticTransitions(self)
        return ret


registerType(Member)

