""" 
Membrane tool interface
"""

try:
    from zope.interface import Interface
    from zope.interface import Attribute
except ImportError:
    from Interface import Interface
    from Interface import Attribute

class membrane_tool(Interface):
    '''This tool interacts with a customized ZCatalog.
    '''
    id = Attribute('id', 'Must be set to "membrane_tool"')

    def registerMembraneType(portal_type):
        """Register a member type,
        by manipulating AT catalog multiplex registry"""

    def unregisterMembraneType(portal_type):
        """Unregister a member type,
        by manipulating AT catalog multiplex registry"""

    def listMembraneTypes():
        """Lists all currently registered member types"""
