#
# MembraneTestCase Membrane
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

import unittest

from Testing import ZopeTestCase
from Products.Membrane.tests import MembraneTestCase
from Products.CMFPlone.utils import _createObjectByType


class MembraneRoleManagerTestBase:

    def _getTargetClass( self ):

        from Products.Membrane.plugins.MembraneRoleManager \
            import MembraneRoleManager

        return MembraneRoleManager

    def _makeOne( self, id='test', *args, **kw ):

        return self._getTargetClass()( id=id, *args, **kw )


class TestMembraneRoleManagerPlugin( MembraneTestCase.MembraneTestCase
                                   , MembraneRoleManagerTestBase):

    def afterSetUp(self):
        self.portal.pmm = self._makeOne('pmm')
        self.addGroup(self.portal)
        self.addUser(self.group)

    def testRoles(self):
        self.portal.acl_users.getUserById(self.member.getUserId())
        # XXX WRITE REAL TEST!!


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestMembraneRoleManagerPlugin))
    return suite

if __name__ == '__main__':
    framework()
