#
# MembraneTestCase Membrane
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.Membrane.tests import MembraneTestCase
from Products.Membrane.config import TOOLNAME


class TestSomething(MembraneTestCase.MembraneTestCase):

    def afterSetUp(self):
        pass

    def testMembraneTypeRegistration(self):
        mt = getattr(self.portal, TOOLNAME)
        pt = 'TestMember'
        self.failUnless(pt in mt.listMembraneTypes())
        mt.unregisterMembraneType(pt)
        self.failIf(pt in mt.listMembraneTypes())
        mt.registerMembraneType(pt)
        self.failUnless(pt in mt.listMembraneTypes())

    def testObjectImplements(self):
        from Products.Membrane.tools.MembraneTool import object_implements
        mt = getattr(self.portal, TOOLNAME)
        self.failUnlessEqual(object_implements(mt, self.portal), ['IZCatalog', 'IPersistent', 'Interface'])


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestSomething))
    return suite

if __name__ == '__main__':
    framework()
